# -*- coding: utf-8 -*-
require 'isono'

module Dcmgr
  module NodeModules
    class StaTgtInitializer < Isono::NodeModules::Base
      include Dcmgr::Helpers::CliHelper
      include Dcmgr::Logger

      initialize_hook do
        EM.defer do
          myinstance.register_volumes
        end
      end

      terminate_hook do
      end

      def register_volumes
        begin
          volumes = rpc.request('sta-collector', 'get_available_volumes', node.node_id)
        rescue Isono::NodeModules::RpcChannel::RpcError
          # do nothing if got:
          #  Caught RuntimeError: Unknown sta node ID: sta.demo1
          logger.warn("Failed to collect available volumes. Ignore to register volumes to IscsiTarget.")
          return
        end
        iscsit = Dcmgr::Drivers::IscsiTarget.select_iscsi_target(Dcmgr::Configurations.sta.iscsi_target, self.node)
        volumes.each { |volume|
          iscsit.register(volume)
        }
      end

      def rpc
        @rpc ||= Isono::NodeModules::RpcChannel.new(@node)
      end
    end
  end
end
